*****************************************************************
* ICAPS.PRG                                                     *
* Custom Programming Services - Herman E. Means, Jr. - 75600,14 *
* Released To The Public Domain - April 14, 1990                *
* Discussion: Function used to uppercase the beginning of each  *
*             new "word" in a field while handling many special *
*             string sequences contained in the field.          *
* Examples: PAUL MCCARTNEY becomes Paul McCartney               *
*           b&o railroad becomes B&O Railroad                   *
* Required: FoxPro 1.x                                          *
* Syntax & Use: @ 7,32 GET mfldname VALID icaps(mfldname)       *
*****************************************************************

FUNCTION ICAPS
   PARAMETER fldcont
   fldname = SYS(18)
   IF EMPTY(&fldname)                  
      RETURN (.T.)                               
   ENDIF                                         
   fldcont = PROPER(fldcont)           
   IF "&" $ fldcont                      
      mOccurs = OCCURS("&",fldcont)    
      FOR i = 1 TO mOccurs
          pos = AT("&",fldcont,i)             
          fldcont = SUBSTR(fldcont,1,pos)+;   
          UPPER(SUBSTR(fldcont,pos+1,1))+;    
          SUBSTR(fldcont,pos+2)               
      ENDFOR
   ENDIF
   IF "." $ fldcont
      mOccurs = OCCURS(".",fldcont)    
      FOR i = 1 TO mOccurs
          pos = AT(".",fldcont,i)             
          fldcont = SUBSTR(fldcont,1,pos)+;   
          UPPER(SUBSTR(fldcont,pos+1,1))+;    
          SUBSTR(fldcont,pos+2)               
      ENDFOR
   ENDIF
   IF "," $ fldcont                    
      mOccurs = OCCURS(",",fldcont)    
      FOR i = 1 TO mOccurs
          pos = AT(",",fldcont,i)             
          fldcont = SUBSTR(fldcont,1,pos)+;   
          UPPER(SUBSTR(fldcont,pos+1,1))+;    
          SUBSTR(fldcont,pos+2)               
      ENDFOR
   ENDIF
   IF "-" $ fldcont
      mOccurs = OCCURS("-",fldcont)    
      FOR i = 1 TO mOccurs
          pos = AT("-",fldcont,i)             
          fldcont = SUBSTR(fldcont,1,pos)+;   
          UPPER(SUBSTR(fldcont,pos+1,1))+;    
          SUBSTR(fldcont,pos+2)               
      ENDFOR
   ENDIF
   IF ATC("Mc",fldcont) > 0
      mOccurs = OCCURS("Mc",fldcont) + OCCURS("mc",fldcont)
      FOR i = 1 TO mOccurs                    
         pos = ATC("Mc",fldcont,i)            
         fldcont = SUBSTR(fldcont,1,pos+1)+;  
         UPPER(SUBSTR(fldcont,pos+2,1))+;     
         SUBSTR(fldcont,pos+3)                
      ENDFOR
   ENDIF
   &fldname = fldcont             
RETURN (.T.)                           
